=== debian/changelog ===
biosig4c++ (1.3.0-2.1build1) xenial; urgency=medium

  * No-change rebuild against suitesparse 1:4.4.5-2

 -- Graham Inggs <graham@nerve.org.za>  Tue, 01 Dec 2015 11:41:43 +0200

biosig4c++ (1.3.0-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Port from python-support to dh_python2. (Closes: #785953)

 -- Stefano Rivera <stefanor@debian.org>  Wed, 19 Aug 2015 20:32:12 +0200

biosig4c++ (1.3.0-2) unstable; urgency=low

  * Do not build biosig_{client,server} which are still experimental and
    actually were not shipped within any package anyway (as a side-effect
    Closes: #675582)

 -- Yaroslav Halchenko <debian@onerussian.com>  Sun, 03 Jun 2012 22:18:19 -0400

biosig4c++ (1.3.0-1) unstable; urgency=low

  * Fresh upstream release
    - libbiosig now SOVERSION 1, thus libbiosig1{,-dbg} to replace
      libbiosig0
  * debian/copyright: updated for DEP5
  * debian/patches:
    - added up_memcpy_str_cast (sent upstream)
    - removed up_for_loop_initial (upstreamed)
    - removed up_*oct* (no hardcoded octave version information in
      upstream Makefile any longer), deb_link_dynamically_python
    - removed deb_link_dynamically in favor of specifying LIBEXT=so to
      calls to make
    - removed deb_use_borrowed_eventcodes: now debian/upstream-extern
      provides needed extra external files (from biosig) and gets symlinked
      as extern at build time
    - refreshed deb_no_mex_copy_upstairs,deb_no_locals
  * upstream-files/eventcodes.txt -- refreshed from online
  * debian/control:
    - new build-depends: gawk, libxml2-dev
    - boosted policy to 3.9.3 -- no further changes

 -- Yaroslav Halchenko <debian@onerussian.com>  Thu, 24 May 2012 09:22:13 -0400

biosig4c++ (0.96.3+svn2677-4) UNRELEASED; urgency=low

  * debian/upstream: Authors need to be separated by ' and ' rather than
    by ','

 -- Andreas Tille <tille@debian.org>  Wed, 09 May 2012 09:48:22 +0200

biosig4c++ (0.96.3+svn2677-3) unstable; urgency=low

  * ACK the .1 NMU (Thank you Miguel)
    - debian/rules: call dh_numpy only if available
  * Use unversioned mkoctfile (Closes: #665051).
    Thanks Lucas Nussbaum for the report and Nicolas Bourdaud for the patch.
  * debian/rules, debian/control
    - fixed typo in debian/control resulting in octave:Depends
    - adjusted conditional use of octave-depends across systems (should
      generate octave:Depends subst for recent systems lacking
      octave-depends)
  * debian/patches: refreshed

 -- Yaroslav Halchenko <debian@onerussian.com>  Wed, 11 Apr 2012 12:36:54 -0400

biosig4c++ (0.96.3+svn2677-2.1) unstable; urgency=low

  * Non-maintainer upload.
  * Fix "missing dependency on python-numpy" by adding dh_numpy under
    override_dh_auto_install (Closes: #641790)

 -- Miguel de Val Borro <miguel.deval@gmail.com>  Fri, 02 Dec 2011 20:02:39 +0100
