=== debian/watch ===
version=3
http://sf.net/biosig/biosig4c\+\+-(.*)\.zip
